Package org.apache.sysds.hops.estim

# Class EstimatorBitsetMM.BitsetMatrix1

java.lang.Object
org.apache.sysds.hops.estim.EstimatorBitsetMM.BitsetMatrix
org.apache.sysds.hops.estim.EstimatorBitsetMM.BitsetMatrix1

Enclosing class:
  EstimatorBitsetMM

public static class EstimatorBitsetMM.BitsetMatrix1 extends EstimatorBitsetMM.BitsetMatrix
This class represents a boolean matrix and provides key operations. In the interest of a cache-conscious matrix multiplication and reduced memory overhead, we use a linearized and padded array of longs instead of Java's BitSet per row (which causes memory overheads per row and does not allow for range ORs). However, this implies a maximum size of 16GB.

## Constructor Summary

Constructors
Constructor
Description
`BitsetMatrix1(int rlen, int clen)`
`BitsetMatrix1(MatrixBlock in)`

## Method Summary

Modifier and Type
Method
Description
`EstimatorBitsetMM.BitsetMatrix`
`and(EstimatorBitsetMM.BitsetMatrix bsb)`
`EstimatorBitsetMM.BitsetMatrix`
`cbind(EstimatorBitsetMM.BitsetMatrix bsb)`
`EstimatorBitsetMM.BitsetMatrix`
`flip()`
`boolean`
`get(int r, int c)`
`EstimatorBitsetMM.BitsetMatrix`
`or(EstimatorBitsetMM.BitsetMatrix bsb)`
`EstimatorBitsetMM.BitsetMatrix`
`rbind(EstimatorBitsetMM.BitsetMatrix bsb)`
`void`
`set(int r, int c)`

### Methods inherited from class org.apache.sysds.hops.estim.EstimatorBitsetMM.BitsetMatrix

`getNonZeros, getNumColumns, getNumRows, matMult, transpose`

### Methods inherited from class java.lang.Object

`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Constructor Details

### BitsetMatrix1

public BitsetMatrix1(int rlen, int clen)

### BitsetMatrix1

public BitsetMatrix1(MatrixBlock in)

## Method Details

### and

public EstimatorBitsetMM.BitsetMatrix and(EstimatorBitsetMM.BitsetMatrix bsb)

### or

public EstimatorBitsetMM.BitsetMatrix or(EstimatorBitsetMM.BitsetMatrix bsb)

### rbind

public EstimatorBitsetMM.BitsetMatrix rbind(EstimatorBitsetMM.BitsetMatrix bsb)

### cbind

public EstimatorBitsetMM.BitsetMatrix cbind(EstimatorBitsetMM.BitsetMatrix bsb)

### flip

public EstimatorBitsetMM.BitsetMatrix flip()

### set

public void set(int r, int c)

Specified by:
  `set` in class `EstimatorBitsetMM.BitsetMatrix`

### get

public boolean get(int r, int c)

Specified by:
  `get` in class `EstimatorBitsetMM.BitsetMatrix`